package com.flyfish.framework.auditor;

import com.flyfish.framework.context.UserContext;
import com.flyfish.framework.domain.authorized.AuthorizedDomain;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;

@Component
@RequiredArgsConstructor
public class AuthorizeAuditor implements BeanAuditor<AuthorizedDomain> {

    private final UserContext userContext;

    /**
     * 对实体进行审查，并补全相关字段
     *
     * @param data 原数据
     * @return 结果
     */
    @Override
    public void audit(AuthorizedDomain data) {
        data.setAuthorizeId(userContext.currentUser().getAuthority());
    }
}
